#include<stdio.h>
#include<string.h>

typedef unsigned short Elf32_Half;
typedef unsigned int   Elf32_Word;
typedef unsigned int   Elf32_Addr;
typedef unsigned int   Elf32_Off;

/*
 * Elf32_Half表示2字节
 * Elf32_Word表示4字节
 * Elf32_Addr表示4字节
 * Elf32_Off 表示4字节
 */
#define EI_NIDENT   16
typedef struct
{
    unsigned char	e_ident[EI_NIDENT];
    Elf32_Half	e_type;			/* Object file type */
    Elf32_Half	e_machine;		/* Architecture */
    Elf32_Word	e_version;		/* Object file version */
    Elf32_Addr	e_entry;		/* Entry point virtual address */
    Elf32_Off	e_phoff;		/* Program header table file offset */
    Elf32_Off	e_shoff;		/* Section header table file offset */
    Elf32_Word	e_flags;		/* Processor-specific flags */
    Elf32_Half	e_ehsize;		/* ELF header size in bytes */
    Elf32_Half	e_phentsize;	/* Program header table entry size */
    Elf32_Half	e_phnum;		/* Program header table entry count */
    Elf32_Half	e_shentsize;	/* Section header table entry size */
    Elf32_Half	e_shnum;		/* Section header table entry count */
    Elf32_Half	e_shstrndx;		/* Section header string table index */
} Elf32_Ehdr;

unsigned int GetBinData(char *filename, unsigned char *buf)
{
    unsigned int  size = 0;
    FILE  *fp = fopen(filename, "rb");
    if (fp)
    {
        fseek(fp, 0, SEEK_END);
        size = ftell(fp);            // fseek + ftell 得到文件大小
        rewind(fp);                  // 设置文件位置为给定文件的开头
        fread(buf, sizeof(unsigned char), size, fp);
        fclose(fp);

        printf("\nfilename=%s,size=%d \n",filename, size);
    }
    else
    {
        printf( "\nCan not open file: %s \n", filename);
    }

    return size;
}

int main(void)
{
	unsigned int  size, i;
	unsigned char hex_buff[1024];
    Elf32_Ehdr *p_elf;

	size=GetBinData("example.o",hex_buff);

    p_elf = (Elf32_Ehdr*)hex_buff;
    printf("ELF头相关内容：\n");
    printf("e_flags = %02x\n",p_elf->e_flags);

	for(i = 0; i < size; i++)
	{
		printf("%02x ",hex_buff[i]);
        if ((i+1) % 16 == 0)
            printf("\n");
	}

	printf("\nread file completely!\n");
    return 0;
}

